part of xfxwidgets;

class XElencoItem extends StatelessWidget {
  XElencoItem(
    this.setState,
    this.xObjOriginal,
    this.context,
    this.xView, {
    this.funct,
    this.xViewDetts,
    this.xLayout_Row_Cell,
    this.xLayout_Row_CellWidth,
    this.liPopUpMenu_Items,
    Key? key,
    this.childMain,
    this.childDetails,
    this.showingDetails = false,
    this.showMainWithDetails = true,
    this.decorationBackGroundContainer,
    this.changeStatoWithTap = true,
    this.onTapItem,
    this.onLongTapItem,
    this.onDoubleTapItem,
    this.margin,
    this.crossAxisAlignment,
    this.backGroundColor_ChildMain,
    this.backGroundColor_ChildDetails,
    this.iconColor_Collapsed,
    this.iconColor_Expanded,
    this.showTrailingArrow = true,
    this.icon_Active,
    this.icon_Disabled,
    this.height_Icon,
    this.size_Icon,
    this.width_Icon,
    this.childMain_CrossAxisAlignment,
    this.widgets_LeftArea,
    this.widgets_RightArea,
    this.edited,
    this.paddingOfItem,
    this.liXActions_LEFT,
    this.liXActions_RIGHT,
    this.liXActions_FAST,
    this.xActions_LEFT_widthArea,
    this.xActions_RIGHT_widthArea,
    this.styleForItemCell,
    this.cellIsFlexible = true,
  }) : super(key: key) {
    if (edited == null) {
      edited = ValueNotifier(false);
    }
    if (styleForItemCell == null) {
      styleForItemCell = (xcol, xfd, color) => XStyles.xStyTextForDescr(textColor: Colors.white);
    }
  }

  /// default TRUE
  XFDataItem xObjOriginal;
  BuildContext context;
  XView xView;
  XView? xViewDetts;
  void Function()? funct;
  Widget Function(XCol xCol, XFDataItem item)? xLayout_Row_Cell;
  double? Function(XCol xCol, XFDataItem item, double? widthByXfx)? xLayout_Row_CellWidth;
  List<XAction>? liXActions_LEFT;
  List<XAction>? liXActions_RIGHT;
  List<XAction>? liXActions_FAST;
  List<XPopUpMenuItem>? liPopUpMenu_Items = List<XPopUpMenuItem>.empty(growable: true);
  bool showMainWithDetails;
  Widget? childMain;
  bool showingDetails;
  Widget? childDetails;
  List<Widget>? widgets_LeftArea;
  List<Widget>? widgets_RightArea;
  bool changeStatoWithTap;
  bool? showTrailingArrow;
  Color? backGroundColor_ChildMain;
  Color? backGroundColor_ChildDetails;
  Color? iconColor_Expanded;
  Color? iconColor_Collapsed;
  double? width_Icon;
  double? height_Icon;
  double? size_Icon;
  double? xActions_LEFT_widthArea;
  double? xActions_RIGHT_widthArea;
  ValueNotifier<bool>? edited;
  Decoration? decorationBackGroundContainer;
  EdgeInsetsGeometry? margin;
  CrossAxisAlignment? crossAxisAlignment;
  CrossAxisAlignment? childMain_CrossAxisAlignment;
  IconData? icon_Active;
  IconData? icon_Disabled;
  EdgeInsetsGeometry? paddingOfItem;
  Function()? onTapItem;
  Function()? onLongTapItem;
  Function()? onDoubleTapItem;
  TextStyle Function(XCol xcol, XFDataItem? xfd, Color color)? styleForItemCell;
  bool cellIsFlexible;
  void Function(void Function()) setState;
  Widget? xBuilder_childMain() {
    return childMain;
  }

  Widget xLayout_Item_RowWidgets(XCol xCol, XFDataItem item, bool noTextWhenCellValueIsNull, {String formatDate = "dd/MM/yy"}) {
    Widget _xContainerOfWidgets;
    Color xColColor = xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color;
    if (xCol.resizeStyle == 0 && (item[xCol.colKey] == null || item[xCol.colKey].toString().length == 0)) {
      // se sono FLEX e il mio value è NULL, torno Container()
      return Container(height: 0);
    }

    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _xContainerOfWidgets = Text(
        item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : ""),
        maxLines: xCol.multilines
            ? item[xCol.colKey] == ""
                ? 1
                : 3
            : 1,
        style: styleForItemCell == null ? XStyles.xStyTextForDescr(textColor: xColColor) : styleForItemCell!(xCol, item, xColColor),
        overflow: TextOverflow.fade,
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _xContainerOfWidgets = Text(XUtils.dateToString(item[xCol.colKey] ?? DateTime(1900, 01, 01), format: formatDate), maxLines: 1, style: styleForItemCell == null ? XStyles.xStyTextForDescr(textColor: xColColor) : styleForItemCell!(xCol, item, xColColor), overflow: TextOverflow.fade);
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      if (xCol.format == "C") {
        _xContainerOfWidgets = Text(XUtils.xFormatToCurrency(context, item[xCol.colKey] ?? 0.0), style: styleForItemCell == null ? XStyles.xStyTextForDescr(textColor: item[xCol.colKey] == 0.0 ? Colors.grey[600]! : xColColor) : styleForItemCell!(xCol, item, item[xCol.colKey] == 0.0 ? Colors.grey[600]! : xColColor), textAlign: TextAlign.end, overflow: TextOverflow.fade);
        // Se è un un semplice double
      } else {
        _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0.0", style: styleForItemCell == null ? XStyles.xStyTextForDescr(textColor: xColColor) : styleForItemCell!(xCol, item, xColColor), overflow: TextOverflow.fade);
      }
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0", style: styleForItemCell == null ? XStyles.xStyTextForDescr(textColor: xColColor) : styleForItemCell!(xCol, item, xColColor), overflow: TextOverflow.fade);

      //Se fosse una lista e voglio prendere la quantità di oggetti dentro
    } else if (xCol.dataType == bool) {
      _xContainerOfWidgets = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color,
            activeColor: xCol.xmodelXprop.col_Color,
            checkColor: Colors.black,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                funct != null ? funct!() : null;
                edited!.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else if (xCol.dataType == String && (xCol.colKey.startsWith("li"))) {
      _xContainerOfWidgets = Container();
    } else {
      _xContainerOfWidgets = Text(xCol.headerToolTip + (item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : "")), style: styleForItemCell == null ? XStyles.xStyTextForDescr(textColor: xColColor) : styleForItemCell!(xCol, item, xColColor), overflow: TextOverflow.fade);
    }

    //Se la colonna è Width FLEX
    // if (xCol.resizeStyle == 0) {
    //   return Flexible(flex: (xCol.spanX == 0) ? 1 : xCol.spanX, child: Container(margin: EdgeInsets.symmetric(horizontal: 2), child: _xContainerOfWidgets));
    // }
    // //Se la colonna è Width PROPORTIONAL
    // else if (xCol.resizeStyle == 1) {
    //   return Container(constraints: BoxConstraints(minWidth: xCol.minWidth, maxWidth: xCol.maxWidth), margin: EdgeInsets.symmetric(horizontal: 2), child: _xContainerOfWidgets);
    // }
    // //Se la colonna è Width FIX
    // else {
    if (xLayout_Row_Cell == null) {
      //Layout deciso da me
      var wOfCell = cellIsFlexible ? xCol.width * XUtils.kforScale : xCol.width;
      return Container(padding: EdgeInsets.symmetric(horizontal: 2), width: (xLayout_Row_CellWidth == null ? wOfCell : (xLayout_Row_CellWidth!(xCol, item, wOfCell))), child: _xContainerOfWidgets);
    } else {
      return xLayout_Row_Cell!(xCol, item);
    }
    // }
  }

  ///Crazione del PopUp Menu passandogli la lista dei XPopUpMenuItem
  Widget xLayout_BTN_Function(XFDataItem item) {
    return (liPopUpMenu_Items == null || liPopUpMenu_Items!.isEmpty)
        ? Container()
        : Container(
            height: 30,
            child: PopupMenuButton(
              padding: EdgeInsets.all(1),
              icon: Icon(Icons.more_vert_outlined),
              itemBuilder: (context) {
                return liPopUpMenu_Items!
                    .map((e) => PopupMenuItem(
                            child: XBtnbase(
                          decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                          height: 40,
                          width: (e.iconImage != null || e.icon != null) ? 250 : 150,
                          label: e.title,
                          icon_WidthArea: 50,
                          label_Style: XStyles.xStyTextForSubLabel(textColor: e.color),
                          icon_Widget: e.icon != null ? null : Container(width: 50, child: e.iconImage),
                          icon: e.iconImage != null ? null : e.icon,
                          icon_Size: 23,
                          icon_Color: e.iconImage != null ? null : e.color,
                          toolTip_Message: e.toolTip_Message,
                          onPressed: () => e.onPressed!(context, item),
                        )))
                    .toList();
              },
              iconSize: 22,
            ));
  }

  Widget xLayout_BTN_ExpandedItem(XFDataItem item) {
    return XBtnbase(
      icon: item.isShowDetails ? Icons.keyboard_arrow_up_outlined : Icons.keyboard_arrow_down_outlined,
      elevation: 0,
      height: 40,
      width: 40,
      icon_Color: Brightness.dark == true ? Colors.black : Colors.white,
      backGroundColor: Colors.transparent,
      icon_Size: 30,
      onPressed: () => setState(() => item.isShowDetails = item.isShowDetails.not()),
    );
  }

  Widget? xLayout_RowDetts_Widget(XCol xCol, dynamic item) {
    if (xLayout_Row_Cell != null) {
      return xLayout_Row_Cell!(xCol, item);
    } else {
      return null;
    }
  }

  Widget xLayout_DettsRowsArea(dynamic item) {
    List<Widget> _liDettsWidget = List<Widget>.empty(growable: true);
    var res = xView.cols.firstWhereOrNull((element) {
      return element.colKey.startsWith("li");
    });
    List<dynamic> t = List<dynamic>.empty(growable: true);
    if (res != null) {
      t = item.getProp(res.colKey);
    }
    return (res != null)
        ? Container(
            padding: EdgeInsets.only(bottom: 10, left: 5, right: 5),
            child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: t
                    .map((e) => Row(
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: xViewDetts!.cols
                            .map(
                              (xclCol) => (xLayout_RowDetts_Widget(xclCol, e) != null)
                                  ? (xLayout_RowDetts_Widget(xclCol, t) ?? Container()) //
                                  : xLayout_Item_RowWidgets(xclCol, e, true),
                            )
                            .toList()))
                    .toList())) //
        : Container(padding: EdgeInsets.only(bottom: 10), child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [Expanded(child: Text("Nessun elemento", textAlign: TextAlign.center, style: XStyles.xStyTextForDescr()))])); //
  }

  // List<XAction>? xActions_left = List<XAction>.empty(growable: true);
  // List<XAction>? xActions_right = List<XAction>.empty(growable: true);
  @override
  Widget build(BuildContext context) {
    var x = xView.cols.firstWhereOrNull((element) {
      return element.colKey.startsWith("li");
    });
    var t;
    if (x != null) {
      t = xObjOriginal.getProp(x.colKey);
    }

    List<dynamic> li = List<dynamic>.empty(growable: true);
    li.clear();
    if (x != null) {
      li.addAll(xObjOriginal[x.colKey]);
    } else {
      li = [];
    }

    return (liXActions_LEFT != null || liXActions_LEFT!.isNotEmpty) && (liXActions_RIGHT != null || liXActions_RIGHT!.isNotEmpty)
        ? Slidable(
            key: ValueKey(0),
            startActionPane: liXActions_LEFT == null || liXActions_LEFT!.isEmpty
                ? null
                : ActionPane(
                    motion: ScrollMotion(),
                    extentRatio: xActions_LEFT_widthArea ?? (liXActions_LEFT!.length > 1 ? 0.5 : 0.3),
                    dragDismissible: false,
                    //solo se abilitiamo di non vedere righe
                    // dismissible: DismissiblePane(onDismissed: () {}),
                    children: [
                        Container(

                            // margin: margin == null ? EdgeInsets.only(top: 4) : null,
                            alignment: Alignment.topRight,
                            child: Wrap(
                                spacing: 7,
                                runSpacing: 7,
                                runAlignment: WrapAlignment.center,
                                alignment: WrapAlignment.center,
                                direction: Axis.vertical,
                                children: liXActions_LEFT!
                                    .map((xclAction) => XSlidableAction(
                                          flex: 1,
                                          autoClose: true,
                                          // margin: EdgeInsets.only(bottom: 3),
                                          onPressed: (context) async {
                                            if (xclAction.key! == "DEL") {
                                              if (onLongTapItem != null) {
                                                onLongTapItem!();
                                              }
                                            } else {
                                              await xclAction.cmd!(xObjOriginal, setState);
                                            }
                                          },
                                          backgroundColor: xclAction.background_Color ?? Colors.grey[900]!,
                                          foregroundColor: xclAction.label_Color ?? Colors.white,
                                          icon: xclAction.icon ?? null,
                                          icon_Image: xclAction.icon_Image ?? null,
                                          label: xclAction.label ?? "",
                                        ))
                                    .toList()))
                      ]),
            endActionPane: liXActions_RIGHT == null || liXActions_RIGHT!.isEmpty
                ? null
                : ActionPane(motion: ScrollMotion(), extentRatio: xActions_RIGHT_widthArea ?? (liXActions_RIGHT!.length > 1 ? 0.5 : 0.3), dragDismissible: false, children: [
                    Container(
                        // margin: margin == null ? EdgeInsets.only(top: 4) : null,
                        alignment: Alignment.center,
                        child: Wrap(
                            spacing: 7,
                            runSpacing: 7,
                            runAlignment: WrapAlignment.center,
                            alignment: WrapAlignment.center,
                            direction: Axis.vertical,
                            children: liXActions_RIGHT!
                                .map((xclAction) => XSlidableAction(
                                      flex: 1,
                                      autoClose: false,
                                      // margin: EdgeInsets.only(bottom: 3),
                                      onPressed: (context) async {
                                        if (xclAction.key! == "DEL") {
                                          if (onLongTapItem != null) {
                                            onLongTapItem!();
                                          }
                                        } else {
                                          await xclAction.cmd!(xObjOriginal, setState);
                                        }
                                      },
                                      backgroundColor: xclAction.background_Color ?? Colors.grey[900]!,
                                      foregroundColor: xclAction.label_Color ?? Colors.white,
                                      icon: xclAction.icon ?? null,
                                      icon_Image: xclAction.icon_Image ?? null,
                                      label: xclAction.label ?? "",
                                    ))
                                .toList()))
                  ]),
            child: Container(
                decoration: decorationBackGroundContainer ?? BoxDecoration(),
                margin: margin ?? EdgeInsets.only(bottom: 2),
                child: Column(crossAxisAlignment: crossAxisAlignment ?? CrossAxisAlignment.center, children: [
                  (showMainWithDetails == false && showingDetails == true)
                      ? Container()
                      : Container(
                          padding: widgets_LeftArea != null ? null : paddingOfItem ?? EdgeInsets.all(5),
                          color: backGroundColor_ChildMain,
                          child: Row(crossAxisAlignment: childMain_CrossAxisAlignment ?? CrossAxisAlignment.center, children: [
                            (widgets_LeftArea != null) ? Row(mainAxisSize: MainAxisSize.min, children: widgets_LeftArea ?? []) : Container(width: 0, height: 0),
                            Expanded(
                                child: onTapItem != null
                                    ? GestureDetector(
                                        onTap: changeStatoWithTap
                                            ? onTapItem ??
                                                () {
                                                  setState(() => showingDetails = !showingDetails);
                                                }
                                            : null,
                                        // onLongPress: () async {
                                        //   if (onLongTapItem != null) {
                                        //     onLongTapItem!();
                                        //   }
                                        // },
                                        onDoubleTap: onDoubleTapItem ?? () {},
                                        child: childMain != null
                                            ? xBuilder_childMain() ?? Container()
                                            : Container(
                                                color: showingDetails ? backGroundColor_ChildMain : Colors.grey[900],
                                                padding: EdgeInsets.symmetric(vertical: 2, horizontal: 2),
                                                child: Row(children: [
                                                  Expanded(
                                                      child: Container(
                                                          decoration: xObjOriginal.isShowDetails && xViewDetts != null ? BoxDecoration(border: Border(bottom: BorderSide(width: 1, color: Colors.white))) : null,
                                                          padding: EdgeInsets.symmetric(horizontal: 2, vertical: 6),
                                                          child: Row(children: [
                                                            Expanded(
                                                                child: Column(
                                                                    crossAxisAlignment: CrossAxisAlignment.start,
                                                                    children: xView.cols.groupListsBy((element) => element.originY).entries.map((e) {
                                                                      return Wrap(
                                                                          spacing: 0,
                                                                          runSpacing: 0,
                                                                          children: e.value.map((e) {
                                                                            return xLayout_Item_RowWidgets(e, xObjOriginal, false);
                                                                          }).toList());
                                                                    }).toList())),
                                                            (li.isNotEmpty && xViewDetts != null) ? Text((xViewDetts!.title ?? "") + ": " + (li.isNotEmpty ? (li.length.toString()) : "0"), style: XStyles.xStyTextForDescr(textColor: Colors.white), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis) : Container(),
                                                            xLayout_BTN_Function(xObjOriginal),
                                                            (t != null && t.isNotEmpty) ? xLayout_BTN_ExpandedItem(xObjOriginal) : Container()
                                                          ]))),
                                                  (changeStatoWithTap == true && showTrailingArrow == true)
                                                      ? Container(
                                                          alignment: Alignment.center,
                                                          // margin: EdgeInsets.only(top: 10),
                                                          padding: EdgeInsets.all(1),
                                                          width: width_Icon ?? 40,
                                                          height: height_Icon ?? 40,
                                                          child: Icon(
                                                            showingDetails ? icon_Active ?? Icons.keyboard_arrow_up_outlined : icon_Disabled ?? icon_Active ?? Icons.keyboard_arrow_down_outlined,
                                                            color: (showingDetails == false) ? iconColor_Collapsed ?? Colors.grey : iconColor_Expanded ?? Colors.yellow,
                                                            size: size_Icon ?? 28,
                                                          ))
                                                      : Container(width: 0, height: 0)
                                                ])))
                                    : childMain != null
                                        ? xBuilder_childMain() ?? Container()
                                        : Container(
                                            color: showingDetails ? backGroundColor_ChildMain : Colors.grey[900],
                                            padding: EdgeInsets.symmetric(vertical: 2, horizontal: 2),
                                            child: Row(children: [
                                              Expanded(
                                                  child: Container(
                                                      decoration: xObjOriginal.isShowDetails && xViewDetts != null ? BoxDecoration(border: Border(bottom: BorderSide(width: 1, color: Colors.white))) : null,
                                                      padding: EdgeInsets.symmetric(horizontal: 2, vertical: 6),
                                                      child: Row(children: [
                                                        Expanded(
                                                            child: Column(
                                                                crossAxisAlignment: CrossAxisAlignment.start,
                                                                children: xView.cols.groupListsBy((element) => element.originY).entries.map((e) {
                                                                  return Wrap(
                                                                      spacing: 0,
                                                                      runSpacing: 0,
                                                                      children: e.value.map((e) {
                                                                        return xLayout_Item_RowWidgets(e, xObjOriginal, false);
                                                                      }).toList());
                                                                }).toList())),
                                                        (li.isNotEmpty && xViewDetts != null) ? Text((xViewDetts!.title ?? "") + ": " + (li.isNotEmpty ? (li.length.toString()) : "0"), style: XStyles.xStyTextForDescr(textColor: Colors.white), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis) : Container(),
                                                        xLayout_BTN_Function(xObjOriginal),
                                                        (t != null && t.isNotEmpty) ? xLayout_BTN_ExpandedItem(xObjOriginal) : Container()
                                                      ]))),
                                              (changeStatoWithTap == true && showTrailingArrow == true)
                                                  ? Container(
                                                      alignment: Alignment.center,
                                                      // margin: EdgeInsets.only(top: 10),
                                                      padding: EdgeInsets.all(1),
                                                      width: width_Icon ?? 40,
                                                      height: height_Icon ?? 40,
                                                      child: Icon(
                                                        showingDetails ? icon_Active ?? Icons.keyboard_arrow_up_outlined : icon_Disabled ?? icon_Active ?? Icons.keyboard_arrow_down_outlined,
                                                        color: (showingDetails == false) ? iconColor_Collapsed ?? Colors.grey : iconColor_Expanded ?? Colors.yellow,
                                                        size: size_Icon ?? 28,
                                                      ))
                                                  : Container(width: 0, height: 0)
                                            ]))),
                            (widgets_RightArea != null) ? Row(mainAxisSize: MainAxisSize.min, children: widgets_RightArea ?? []) : Container(width: 0, height: 0),
                          ])),
                  Container(
                    color: backGroundColor_ChildDetails ?? backGroundColor_ChildMain,
                    child: Column(
                      children: [
                        // showingDetails.not() ? xLayout_DettsRowsArea(xObjOriginal) : Container(),
                        (showingDetails ? childDetails! : Container())
                      ],
                    ),
                  ),
                ])))
        : Container(
            decoration: decorationBackGroundContainer ?? BoxDecoration(),
            margin: margin ?? EdgeInsets.only(bottom: 2),
            child: Column(crossAxisAlignment: crossAxisAlignment ?? CrossAxisAlignment.center, children: [
              (showMainWithDetails == false && showingDetails == true)
                  ? Container()
                  : Container(
                      padding: widgets_LeftArea != null ? null : paddingOfItem ?? EdgeInsets.all(5),
                      color: backGroundColor_ChildMain,
                      child: Row(crossAxisAlignment: childMain_CrossAxisAlignment ?? CrossAxisAlignment.center, children: [
                        (widgets_LeftArea != null) ? Row(mainAxisSize: MainAxisSize.min, children: widgets_LeftArea ?? []) : Container(width: 0, height: 0),
                        Expanded(
                            child: onTapItem != null
                                ? GestureDetector(
                                    onTap: changeStatoWithTap
                                        ? onTapItem ??
                                            () {
                                              setState(() => showingDetails = !showingDetails);
                                            }
                                        : null,
                                    onLongPress: () async {
                                      if (onLongTapItem != null) {
                                        onLongTapItem!();
                                      }
                                    },
                                    onDoubleTap: onDoubleTapItem ?? () {},
                                    child: childMain != null
                                        ? xBuilder_childMain() ?? Container()
                                        : Container(
                                            color: showingDetails ? backGroundColor_ChildMain : Colors.grey[900],
                                            padding: EdgeInsets.symmetric(vertical: 2, horizontal: 2),
                                            child: Row(children: [
                                              Expanded(
                                                  child: Container(
                                                      decoration: xObjOriginal.isShowDetails && xViewDetts != null ? BoxDecoration(border: Border(bottom: BorderSide(width: 1, color: Colors.white))) : null,
                                                      padding: EdgeInsets.symmetric(horizontal: 2, vertical: 6),
                                                      child: Row(children: [
                                                        Expanded(
                                                            child: Column(
                                                                crossAxisAlignment: CrossAxisAlignment.start,
                                                                children: xView.cols.groupListsBy((element) => element.originY).entries.map((e) {
                                                                  return Wrap(
                                                                      spacing: 0,
                                                                      runSpacing: 0,
                                                                      children: e.value.map((e) {
                                                                        return xLayout_Item_RowWidgets(e, xObjOriginal, false);
                                                                      }).toList());
                                                                }).toList())),
                                                        (li.isNotEmpty && xViewDetts != null) ? Text((xViewDetts!.title ?? "") + ": " + (li.isNotEmpty ? (li.length.toString()) : "0"), style: XStyles.xStyTextForDescr(textColor: Colors.white), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis) : Container(),
                                                        xLayout_BTN_Function(xObjOriginal),
                                                        (t != null && t.isNotEmpty) ? xLayout_BTN_ExpandedItem(xObjOriginal) : Container()
                                                      ]))),
                                              (changeStatoWithTap == true && showTrailingArrow == true)
                                                  ? Container(
                                                      alignment: Alignment.center,
                                                      // margin: EdgeInsets.only(top: 10),
                                                      padding: EdgeInsets.all(1),
                                                      width: width_Icon ?? 40,
                                                      height: height_Icon ?? 40,
                                                      child: Icon(
                                                        showingDetails ? icon_Active ?? Icons.keyboard_arrow_up_outlined : icon_Disabled ?? icon_Active ?? Icons.keyboard_arrow_down_outlined,
                                                        color: (showingDetails == false) ? iconColor_Collapsed ?? Colors.grey : iconColor_Expanded ?? Colors.yellow,
                                                        size: size_Icon ?? 28,
                                                      ))
                                                  : Container(width: 0, height: 0)
                                            ])))
                                : childMain != null
                                    ? xBuilder_childMain() ?? Container()
                                    : Container(
                                        color: showingDetails ? backGroundColor_ChildMain : Colors.grey[900],
                                        padding: EdgeInsets.symmetric(vertical: 2, horizontal: 2),
                                        child: Row(children: [
                                          Expanded(
                                              child: Container(
                                                  decoration: xObjOriginal.isShowDetails && xViewDetts != null ? BoxDecoration(border: Border(bottom: BorderSide(width: 1, color: Colors.white))) : null,
                                                  padding: EdgeInsets.symmetric(horizontal: 2, vertical: 6),
                                                  child: Row(children: [
                                                    Expanded(
                                                        child: Column(
                                                            crossAxisAlignment: CrossAxisAlignment.start,
                                                            children: xView.cols.groupListsBy((element) => element.originY).entries.map((e) {
                                                              return Wrap(
                                                                  spacing: 0,
                                                                  runSpacing: 0,
                                                                  children: e.value.map((e) {
                                                                    return xLayout_Item_RowWidgets(e, xObjOriginal, false);
                                                                  }).toList());
                                                            }).toList())),
                                                    (li.isNotEmpty && xViewDetts != null) ? Text((xViewDetts!.title ?? "") + ": " + (li.isNotEmpty ? (li.length.toString()) : "0"), style: XStyles.xStyTextForDescr(textColor: Colors.white), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis) : Container(),
                                                    xLayout_BTN_Function(xObjOriginal),
                                                    (t != null && t.isNotEmpty) ? xLayout_BTN_ExpandedItem(xObjOriginal) : Container()
                                                  ]))),
                                          (changeStatoWithTap == true && showTrailingArrow == true)
                                              ? Container(
                                                  alignment: Alignment.center,
                                                  // margin: EdgeInsets.only(top: 10),
                                                  padding: EdgeInsets.all(1),
                                                  width: width_Icon ?? 40,
                                                  height: height_Icon ?? 40,
                                                  child: Icon(
                                                    showingDetails ? icon_Active ?? Icons.keyboard_arrow_up_outlined : icon_Disabled ?? icon_Active ?? Icons.keyboard_arrow_down_outlined,
                                                    color: (showingDetails == false) ? iconColor_Collapsed ?? Colors.grey : iconColor_Expanded ?? Colors.yellow,
                                                    size: size_Icon ?? 28,
                                                  ))
                                              : Container(width: 0, height: 0)
                                        ]))),
                        (widgets_RightArea != null) ? Row(mainAxisSize: MainAxisSize.min, children: widgets_RightArea ?? []) : Container(width: 0, height: 0),
                      ])),
              Container(
                color: backGroundColor_ChildDetails ?? backGroundColor_ChildMain,
                child: Column(
                  children: [
                    // showingDetails.not() ? xLayout_DettsRowsArea(xObjOriginal) : Container(),
                    (showingDetails ? childDetails! : Container())
                  ],
                ),
              ),
            ]));
  }

  Future<bool> xCMD_DeleteFromList(XFDataItem item, String title) async {
    bool res = await showDialog(
        barrierDismissible: false,
        context: context,
        builder: (builder) {
          return XAlertDialog(
            btnNO_label: "NO",
            btnYES_label: "SI",
            btnYES_OnPressed: () => Navigator.pop(context, true),
            btnNO_OnPressed: () => Navigator.pop(context, false),
            title_Text: title,
            title_Style: XStyles.xStyTextForSubLabel(textColor: Colors.yellow),
          );
        });
    return res;
  }
}

class XSlidableAction extends SlidableAction {
  Uint8List? icon_Image;
  double icon_Image_W;
  double icon_Image_H;
  EdgeInsetsGeometry? margin;
  Widget? action_Child;
  XSlidableAction({
    super.onPressed,
    super.autoClose,
    super.backgroundColor,
    super.borderRadius,
    super.flex,
    super.foregroundColor,
    super.icon,
    super.key,
    super.label,
    super.padding,
    super.spacing,
    this.icon_Image,
    this.icon_Image_W = 40,
    this.icon_Image_H = 40,
    this.margin,
    this.action_Child,
  });
  @override
  Widget build(BuildContext context) {
    final children = <Widget>[];

    if (icon != null && icon_Image == null) {
      children.add(
        Icon(icon),
      );
    }

    if (icon_Image != null && icon == null) {
      children.add(
        Image.memory(icon_Image!, width: icon_Image_W, height: icon_Image_H),
      );
    }

    if (label != null && label != "") {
      if (children.isNotEmpty) {
        children.add(
          SizedBox(height: spacing),
        );
      }

      children.add(
        FittedBox(
            child: Text(
          label!,
          style: XStyles.xStyTextForDescr(textColor: foregroundColor ?? Colors.white),
          overflow: TextOverflow.ellipsis,
        )),
      );
    }

    final child = action_Child != null
        ? Container()
        : children.length == 1
            ? children.first
            : Column(
                mainAxisAlignment: MainAxisAlignment.center,
                mainAxisSize: MainAxisSize.min,
                children: [
                  ...children.map(
                    (child) => Container(
                      child: child,
                    ),
                  )
                ],
              );

    return XCustomSlidableAction(
      borderRadius: borderRadius,
      padding: padding,
      onPressed: onPressed,
      autoClose: autoClose,
      backgroundColor: backgroundColor,
      foregroundColor: foregroundColor,
      flex: flex,
      margin: margin,
      child: child,
      action_Child: action_Child,
    );
  }
}

class XCustomSlidableAction extends CustomSlidableAction {
  EdgeInsetsGeometry? margin;
  Widget? action_Child;
  XCustomSlidableAction({
    super.key,
    super.flex,
    super.backgroundColor,
    super.foregroundColor,
    super.autoClose,
    super.borderRadius = BorderRadius.zero,
    super.padding,
    required super.onPressed,
    required super.child,
    this.margin,
    this.action_Child,
  });
  @override
  Widget build(BuildContext context) {
    final effectiveForegroundColor = foregroundColor ?? (ThemeData.estimateBrightnessForColor(backgroundColor) == Brightness.light ? Colors.black : Colors.white);
    return action_Child != null
        ? action_Child ?? Container()
        : action_Child == null
            ? Container(
                width: 95,
                margin: margin ?? EdgeInsets.only(bottom: 0),
                child: OutlinedButton(
                  onPressed: () => _handleTap(context),
                  style: OutlinedButton.styleFrom(
                    foregroundColor: effectiveForegroundColor,
                    padding: EdgeInsets.all(3),
                    disabledForegroundColor: effectiveForegroundColor.withOpacity(0.38),
                    backgroundColor: backgroundColor,
                    shape: RoundedRectangleBorder(borderRadius: borderRadius),
                    side: BorderSide.none,
                  ),
                  child: child,
                ))
            : Container();
  }

  void _handleTap(BuildContext context) {
    onPressed?.call(context);
    if (autoClose) {
      Slidable.of(context)?.close();
    }
  }
}
