part of xsch;

extension BuilderSchWidget on XSchedaState {
  calcCell_Negative(XCol xCol, TextEditingController controller, numForCalc) {
    var x;
    if (controller.text == "") {
    } else {
      if (xCol.dataType == double) {
        x = double.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      } else if (xCol.dataType == int) {
        x = int.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      } else {
        x = int.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      }
    }

    return x;
  }

  calcCell_Positive(XCol xCol, TextEditingController controller, numForCalc) {
    var x;
    if (xCol.dataType == double) {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = double.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    } else if (xCol.dataType == int) {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = int.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    } else {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = int.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    }
    return x;
  }

  calcSconto(TextEditingController controller, String value) {
    if (controller.text == "") {
      return value.replaceAll("+", "");
    } else {
      return value;
    }
  }

//Dialog per l'editing dei Numeri non Importi
  Widget xEditDialog_Number(XFDataItem item, XCol xCol, TextEditingController textController, void Function(void Function())? parentSetState, {bool btnNumberActive = true}) {
    return Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
      btnNumberActive
          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
              Expanded(
                  child: Wrap(spacing: 6, runSpacing: 6, children: [
                builderXEditDialog_BTNs(item, textController, "-20", false, parentSetState!, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "-10", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "-5", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "-3", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "-1", false, parentSetState, xCol: xCol),
              ]))
            ])
          : Container(height: 0),
      SizedBox(height: btnNumberActive ? 10 : 1),
      Row(mainAxisAlignment: MainAxisAlignment.center, children: [
        Expanded(
            child: XTextFormField(
          height: null,
          textAlign: TextAlign.end,
          controller: textController,
          // autoFocus: true,
          // initialValue: sconto.text,
          contentPadding: EdgeInsets.all(7),
          keyboardType: TextInputType.number,
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,.\\\\]"))],
          // onChanged: (value) {
          //   sconto.text = value;
          // },
        )),
        // Expanded(child: xEditDialog_CellBuilder(item, xCol, context, parentSetState!, textController, inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))], keyboardType: TextInputType.number, autoFocus: false)),
        SizedBox(width: 10),
        builderXEditDialog_BTNs(item, textController, "C", false, parentSetState!),
      ]),
      SizedBox(height: btnNumberActive ? 10 : 1),
      btnNumberActive
          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
              Expanded(
                  child: Wrap(spacing: 6, runSpacing: 6, children: [
                builderXEditDialog_BTNs(item, textController, "+20", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "+10", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "+5", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "+3", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "+1", false, parentSetState, xCol: xCol),
              ]))
            ])
          : Container(height: 0)
    ]);
  }

//Dialog per l'editing dello sconto
  Widget xEditDialog_Sconto(
    XFDataItem item,
    XCol xCol,
    TextEditingController textController,
    void Function(void Function())? parentSetState, {
    List<ScontiBTN>? liSconti,
    bool calc = false,
  }) {
    return Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
      Row(children: [
        Expanded(child: Container(decoration: BoxDecoration(border: Border.all(color: Colors.white)), child: Text(textController.text, style: XStyles.xStyTextForSubLabel()))),
        XBtnbase(
            icon: Icons.arrow_back,
            width: 50,
            height: 50,
            onPressed: () {
              parentSetState!(() {
                if (textController.text.contains("+")) {
                  var x = textController.text.split("+");
                  if (x.length > 1) {
                    textController.text = textController.text.replaceRange(textController.text.length - 3, textController.text.length, "");
                  } else {
                    textController.text = "";
                  }
                } else {
                  textController.text = "";
                }
              });
            })
      ]),
      SizedBox(height: 10),
      Row(children: [
        Expanded(
            child: Column(children: [
          Row(mainAxisAlignment: MainAxisAlignment.center, children: [
            Expanded(
                child: Wrap(
                    alignment: WrapAlignment.end,
                    spacing: 6,
                    runSpacing: 6,
                    children: liSconti != null
                        ? liSconti.where((element) => element.positionY == 0 && element.positionX == null).map((e) => builderXEditDialog_BTNs(item, textController, e.scontoValue, true, parentSetState!)).toList()
                        : [
                            builderXEditDialog_BTNs(item, textController, "+25", true, parentSetState!),
                            builderXEditDialog_BTNs(item, textController, "+40", true, parentSetState),
                            builderXEditDialog_BTNs(item, textController, "+48", true, parentSetState),
                          ]))
          ]),
          SizedBox(height: 10),
          Row(children: [
            calc
                ? Container()
                : Expanded(
                    child: XTextFormField(
                    height: null,
                    textAlign: TextAlign.end,
                    controller: sconto_Controller,
                    // autoFocus: true,
                    // initialValue: sconto.text,
                    contentPadding: EdgeInsets.all(7),
                    keyboardType: TextInputType.number,
                    inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,.\\\\]"))],
                    // onChanged: (value) {
                    //   sconto.text = value;
                    // },
                  ))
          ]),
          SizedBox(height: 10),
          Row(mainAxisAlignment: MainAxisAlignment.center, children: [
            Expanded(
                child: Wrap(
              alignment: WrapAlignment.end,
              spacing: 6,
              runSpacing: 6,
              children: liSconti != null
                  ? liSconti.where((element) => element.positionY == 1 && element.positionX == null).map((e) => builderXEditDialog_BTNs(item, textController, e.scontoValue, true, parentSetState!)).toList()
                  : [
                      builderXEditDialog_BTNs(item, textController, "+20", true, parentSetState!),
                      builderXEditDialog_BTNs(item, textController, "+15", true, parentSetState),
                      builderXEditDialog_BTNs(item, textController, "+10", true, parentSetState),
                    ],
            ))
          ])
        ])),
        Container(
          width: 50,
          child: Column(mainAxisSize: MainAxisSize.min, children: [
            Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: liSconti != null
                    ? liSconti.where((element) => element.positionY == 0 && element.positionX != null && element.positionX! > 1).map((e) => builderXEditDialog_BTNs(item, textController, e.scontoValue, true, parentSetState!)).toList()
                    : [
                        builderXEditDialog_BTNs(item, textController, "+50", true, parentSetState!),
                      ]),
            SizedBox(height: 7),
            XBtnbase(
                icon: Icons.add,
                width: 50,
                height: 40,
                onPressed: () {
                  parentSetState!(() {
                    if (sconto_Controller.text.length < 1) {
                    } else {
                      if (textController.text == "") {
                        textController.text += sconto_Controller.text;
                      } else {
                        textController.text += ("+" + sconto_Controller.text);
                      }
                      sconto_Controller.text = "";
                    }
                  });
                  sconto_Controller.clear();
                }),
            SizedBox(height: 7),
            Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: liSconti != null
                    ? liSconti.where((element) => element.positionY == 1 && element.positionX != null && element.positionX! > 1).map((e) => builderXEditDialog_BTNs(item, textController, e.scontoValue, true, parentSetState!)).toList()
                    : [
                        builderXEditDialog_BTNs(item, textController, "+5", true, parentSetState!),
                      ]),
          ]),
        )
      ]),
    ]);
  }

//Dialog per l'editing dei campi con i vari pulsanti di help
  Future<dynamic> xEditDialog(XFDataItem item, String title, dynamic value, XCol xCol, {List<ScontiBTN>? liSconti}) async {
    FocusScope.of(context).unfocus();
    TextEditingController textController = TextEditingController(
        text: item[xCol.colKey].runtimeType != DateTime
            ? item[xCol.colKey].toString()
            : item[xCol.colKey] != null
                ? XUtils.dateToString(item[xCol.colKey], format: "dd/MM/yyyy", noDateLabel: "")
                : XUtils.dateToString(DateTime.now(), format: "dd/MM/yyyy", noDateLabel: ""));
    if (enteredInEditOnCell) {
    } else {
      setState(() {
        enteredInEditOnCell = true;
      });
    }
    var res = await showDialog<dynamic>(
        context: context,
        barrierDismissible: false,
        builder: (context) {
          return StatefulBuilder(
            builder: (context, setState) {
              return Container(
                  width: MediaQuery.of(context).size.width - 10,
                  alignment: Alignment.center,
                  child: SingleChildScrollView(
                      child: XAlertDialog(
                          colorBackGround: XSchedaState.color_BackGround_EditDialog,
                          actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
                          content_insetPadding: EdgeInsets.all(2),
                          height: null,
                          title_Text: title,
                          title_Style: XStyles.xStyTextForLabel(textColor: Colors.blue),
                          btnYES_label: "OK",
                          btnNO_label: "Annulla",
                          btnNO_OnPressed: () {
                            Navigator.pop(context, null);
                          },
                          btnYES_OnPressed: () {
                            if (value != textController.text) {
                              setState(() {
                                editedPage.value = true;
                              });
                            }
                            if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
                              value = textController.text;
                            } else if (xCol.dataType == DateTime) {
                              value = item[xCol.colKey];
                            } else if (xCol.dataType == double) {
                              value = double.parse(textController.text);
                            } else if (xCol.dataType == int) {
                              value = int.parse(textController.text);
                            }
                            // lo fa già xOnXCell_Edit_SubmitValue
                            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                            Navigator.pop(context, value);
                          },
                          child: xEditDialog_Override_Editor(xCol.colCaption, value, xCol, textController, item: item) != null
                              ? xEditDialog_Override_Editor(xCol.colCaption, value, xCol, textController, item: item)
                              : (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != DateTime && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                  ? xEditDialog_Sconto(item, xCol, textController, setState, liSconti: liSconti)
                                  : Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
                                      // ((xCol.dataType == String).not() && xCol.dataType != DateTime)
                                      //     ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                      //         Expanded(
                                      //             child: Wrap(alignment: WrapAlignment.end, spacing: 8, runSpacing: 8, children: [
                                      //           builderXEditDialog_BTNs(item, textController, "-20", false, setState, xCol: xCol),
                                      //           builderXEditDialog_BTNs(item, textController, "-10", false, setState, xCol: xCol),
                                      //           builderXEditDialog_BTNs(item, textController, "-5", false, setState, xCol: xCol),
                                      //           builderXEditDialog_BTNs(item, textController, "-3", false, setState, xCol: xCol),
                                      //           xCol.dataType == String && xCol.colKey.startsWith("li").not() ? Container(height: 0, width: 0) : builderXEditDialog_BTNs(item, textController, "-1", false, setState, xCol: xCol),
                                      //         ]))
                                      //       ])
                                      //     : Container(),
                                      SizedBox(height: 10),
                                      (xCol.dataType == String && xCol.colKey.startsWith("li").not() && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                              Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController)),
                                              SizedBox(width: 10),
                                              builderXEditDialog_BTNs(item, textController, "C", false, setState),
                                            ])
                                          : xCol.dataType == String && xCol.colKey.startsWith("li").not()
                                              ? Column(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                  Row(children: [Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController))]),
                                                  SizedBox(height: 10),
                                                  Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                                                    XBtnbase(
                                                      width: 60,
                                                      label: "Copia \nTutto",
                                                      label_TextAlign: TextAlign.center,
                                                      label_Color: Colors.white,
                                                      padding: EdgeInsets.all(0),
                                                      backGroundColor: Colors.grey[700],
                                                      onPressed: () {
                                                        Clipboard.setData(ClipboardData(text: textController.text));
                                                        ScaffoldMessenger.of(context).showSnackBar(
                                                          SnackBar(content: Text('Testo copiato negli appunti')),
                                                        );
                                                      },
                                                    ),
                                                    SizedBox(width: 20),
                                                    builderXEditDialog_BTNs(item, textController, "C", false, setState),
                                                  ])
                                                ])
                                              : xCol.dataType == DateTime
                                                  ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                      Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController)),
                                                    ])
                                                  : Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                      Expanded(child: xEditDialog_CellBuilder(item, xCol, context, setState, textController)),
                                                      SizedBox(width: 10),
                                                      builderXEditDialog_BTNs(item, textController, "C", false, setState),
                                                    ]),
                                      SizedBox(height: 10),
                                      ((xCol.dataType == String).not() && xCol.dataType != DateTime)
                                          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                              Expanded(
                                                  child: Wrap(alignment: WrapAlignment.end, spacing: 8, runSpacing: 8, children: [
                                                builderXEditDialog_BTNs(item, textController, "+20", false, setState, xCol: xCol),
                                                builderXEditDialog_BTNs(item, textController, "+10", false, setState, xCol: xCol),
                                                builderXEditDialog_BTNs(item, textController, "+5", false, setState, xCol: xCol),
                                                builderXEditDialog_BTNs(item, textController, "+3", false, setState, xCol: xCol),
                                                xCol.dataType == String && xCol.colKey.startsWith("li").not() ? Container() : builderXEditDialog_BTNs(item, textController, "+1", false, setState, xCol: xCol),
                                              ]))
                                            ])
                                          : Container(),
                                    ]))));
            },
          );
        });
    return res;
  }

//Gestione dell'aggiunta di un Item
  Future<XFDataItem?> xLayout_DialogAddItem(XView xView, XFDataItem item, void Function(void Function()) setState, {List<ScontiBTN>? liSconti}) async {
    bool isFirst = false;
    int u = 0;
    setState(() {
      enteredInEditOnCell = true;
    });
    XFDataItem? rval = null;
    if (xView.cols.where((e) => e.dataType != bool || e.readOnly != true || e.colKey.startsWith("li").not()).length == 1) {
      isFirst = false;
    } else {
      for (var i in xView.cols) {
        if (i.dataType == bool || i.readOnly == true || i.colKey.startsWith("li")) {
          continue;
        }
        u++;
        var x = await xEditDialog(item, i.colCaption, item[i.colKey], i, liSconti: liSconti);
        if (x == null) {
          if (u == 1) {
            isFirst = true;
          }
          break;
        } else {
          item[i.colKey] = x;
        }
      }
    }

    if (!isFirst) {
      rval = await xPreview_Dialog(xView, item);
    }
    setState(() {
      enteredInEditOnCell = false;
    });
    return rval;
  }

//Preview dell'aggiunta di un nuovo Item
  Future<XFDataItem?> xPreview_Dialog(XView xView, dynamic value, {String? BTNyes_Label, String? title_Text, bool autoFocusOfCells = true}) async {
    sconto_Controller.text = "";
    return await showDialog<XFDataItem?>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                width: MediaQuery.of(context).size.width - 20,
                alignment: Alignment.center,
                child: SingleChildScrollView(
                    child: XAlertDialog(
                  colorBackGround: XSchedaState.color_BackGround_EditDialog,
                  title_Text: title_Text,
                  btnNO_label: "Annulla",
                  btnYES_label: BTNyes_Label ?? "Conferma",
                  btnYES_OnPressed: () {
                    editedPage.value = true;
                    xFillBottomBarActions();
                    return Navigator.pop(context, value);
                  },
                  btnNO_OnPressed: () {
                    return Navigator.pop(context, null);
                  },
                  child: Column(
                    mainAxisSize: MainAxisSize.min,
                    children: xView.cols.map((e) {
                      TextEditingController controller = TextEditingController(text: value[e.colKey].toString());
                      if (e.colKey.startsWith("li").not() && e.dataType != bool && e.readOnly == false) {
                        return Container(margin: EdgeInsets.symmetric(vertical: 5), child: xEditDialog_Override_Editor(e.colCaption, value, e, controller, item: value) ?? xEditDialog_CellBuilder(value, e, context, setState, controller, label_Visible: true, autoFocus: autoFocusOfCells, keyboardType: TextInputType.text));
                      } else {
                        return Container();
                      }
                    }).toList(),
                  ),
                )));
          });
        });
  }

//CellBuilder dellxEntry
  Container xEditDialog_CellBuilder(XFDataItem item, XCol xCol, BuildContext context, void Function(void Function()) setState, TextEditingController controller, {TextInputType? keyboardType, bool autoFocus = true, bool label_Visible = false, List<TextInputFormatter>? inputFormatters}) {
    Widget _widgetForCell = Container();
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        xCol: xCol,
        autoFocus: autoFocus,
        controller: controller,
        label_Visible: label_Visible,
        multiLines: xCol.multilines,
        maxLines: xCol.multilines ? 4 : 1,
        inputFormatters: inputFormatters,
        editable: xCol.readOnly,
        keyboardType: keyboardType,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        onSubmitted: (p0) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, p0);
        },
        onBefore_Edit: () {
          // xOnBefore_Edit(xCol, item);
        },
        // value: item ?? "",
        onChanged: (value) {
          item[xCol.colKey] = value;
          // xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value, setState);
          // xOnXCell_Edit_OnChanged(item, xCol, value);
        },
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          onBefore_Edit: () {},
          value: item[xCol.colKey],
          onDateSelected: (value) {
            item[xCol.colKey] = value;
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      // if (controller.text == "0.0") {
      //   controller.text = "1.0";
      // }
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          label_Visible: label_Visible,
          maxLines: 1,
          borderColor: widget.cell_borderColor,
          borderColor_Disabled: widget.cell_borderColor_Disabled,
          labelColor_Disabled: widget.cell_labelColor_Disabled,
          autoFocus: true,
          onBefore_Edit: () {
            // xOnBefore_Edit(xCol, item);
          },
          keyboardType: TextInputType.number,
          controller: controller,
          // value: controller.text == "0.0" ? "" : double.parse(controller.text).toString(),
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value));
          },
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(item, xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        label_Visible: label_Visible,
        autoFocus: true,
        xCol: xCol,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {
          // xOnBefore_Edit(xCol, item);
        },
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        controller: controller,
        // value: controller.text == "0.0" ? "" : controller.text,
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(item, xCol, 0);
          }
        },
      );
    } else {
      return Container(width: 0, height: 0);
    }

    return Container(
      child: StatefulBuilder(builder: (context, setState) {
        return _widgetForCell;
      }),
    );
    //}
  }

//TextFormField Editor Generico da Usare
  Widget xSch_TextFormField_Builder<T>({
    required BuildContext context,
    required XCol xCol,
    Function(String)? onChanged,
    Function(String)? onSubmitted,
    String? hintText,
    List<TextInputFormatter>? inputFormatters,
    TextInputType? keyboardType,
    bool editable = true,
    bool label_Visible = true,
    bool autoFocus = false,
    String? value,
    bool? selectText,
    bool? multiLines,
    double? height,
    int? maxLines,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Color? backgorundColor,
    Color? textColor,
    Color? backgorundColor_Disabled,
    TextEditingController? controller,
    Function()? onBefore_Edit,
  }) {
    OutlineInputBorder o = OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor_Active ? (xCol.xmodelXprop.col_Color == Colors.black ? (borderColor ?? Colors.grey[400]!) : xCol.xmodelXprop.col_Color) : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[400]!), width: 1));
    return XTextFormField(
      controller: value != null ? null : controller,
      border: o,
      disabledBorder: o,
      enabledBorder: o,
      // byRick: label: label_Visible ? (xCol.colCaption + (xCol.format == "C" ? " €" : "")) : "",
      label: label_Visible ? xCol.colCaption + (editable ? "🔒" : "") : "",
      onChanged: onChanged,
      onFieldSubmitted: (value) {
        onSubmitted == null ? null : onSubmitted(value!);
      },
      autoFocus: autoFocus,
      onTap: () {
        if (controller != null) {
          if (xCol.dataType == String) {
          } else {
            controller.selection = TextSelection(baseOffset: 0, extentOffset: controller.text.length);
          }
        }
        onBefore_Edit!();
      },
      initialValue: controller != null ? null : value,
      // borderVisible: editable.not(),
      maxLines: maxLines,
      isCollapsed: false,
      enabled: editable.not(),
      height: null,
      fillColor: editable ? Colors.transparent : XSchedaState.color_CellBackGorundDisabled,
      filled: XSchedaState.color_CellBackGorundDisabled != null ? true : false,
      multiLines: (xCol.colCaption.toLowerCase().contains("email") || (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")) || xCol.colCaption.toLowerCase().contains("inidrizzo") || xCol.colCaption.toLowerCase().contains("ind"))
          ? false
          : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
              ? false
              : multiLines ?? false,
      suffixIcon: xCol.format == "C" ? Icon(Icons.euro, size: 20) : null,
      suffixIconConstraints: BoxConstraints(maxWidth: 20, minWidth: 20, maxHeight: 30, minHeight: 30),
      contentPadding: EdgeInsets.only(top: 7, left: 5, bottom: 7),
      textStyle: XStyles.xStyleText(colorText: textColor ?? XSchedaState.color_Text),
      textAlign: xCol.dataType is int || xCol.dataType is double ? TextAlign.end : TextAlign.start,
      labelStyle: XStyles.xStyTextForLabel(textColor: xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color), //XSchedaState.colorOfHintText
      keyboardType: keyboardType ??
          ((xCol.colCaption.toLowerCase().contains("email"))
              ? TextInputType.emailAddress
              : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
                  ? TextInputType.phone
                  : (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto"))
                      ? TextInputType.number
                      : TextInputType.text),
      textCapitalization: (xCol.dataType == String && xCol.colKey.startsWith("li").not())
          ? TextCapitalization.sentences //
          : TextCapitalization.none,
      hintText: editable ? "..." : (hintText ?? "..."),
      hintStyle: XStyles.xStyTextForSubDescr(textColor: XSchedaState.color_HintText),
      inputFormatters: inputFormatters ?? [],
    );
  }

//Text Generico da Usare
  Widget xSch_Text_Builder<T>({required BuildContext context, required XCol xCol, required String value, List<TextInputFormatter>? inputFormatters, double? height}) {
    return XTextWithLabel(
      label: xCol.colCaption,
      text: xCol.format == "C" ? XUtils.xFormatToCurrency(context, double.parse(value)) : value,
      text_Style: XStyles.xStyTextForDescr(textColor: Colors.white),
      label_Style: XStyles.xStyTextForLabel(textColor: XSchedaState.color_HintText),
    );
  }

//DateTime Editor Generico da Usare
  Widget xSch_DateFormField_Builder({
    required XCol xCol,
    required Function(DateTime)? onDateSelected,
    bool editable = true,
    DateTime? value,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Function()? onBefore_Edit,
    TextEditingController? controller,
    String? format,
  }) {
    OutlineInputBorder o = OutlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (borderColor_Active ? xCol.xmodelXprop.col_Color : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[800]!), width: 1));
    return GestureDetector(
        child: DateTimeFormField(
            decoration: InputDecoration(
              contentPadding: EdgeInsets.only(right: 2, top: 2, bottom: 2, left: 4),
              hintStyle: XStyles.xStyleText(fontSize: 15, colorText: XSchedaState.color_HintText),
              errorStyle: TextStyle(color: Colors.redAccent),
              border: o,
              disabledBorder: o,
              enabledBorder: o,
              labelText: xCol.colCaption,
              constraints: BoxConstraints(maxHeight: 40),
              labelStyle: value != null
                  ? XStyles.xStyTextForLabel(textColor: xCol.readOnly ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[900]!) : (labelColor_Disabled ?? borderColor ?? Colors.grey[600]!)) //
                  : XStyles.xStyTextForDescr(textColor: editable.not() ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!) : (xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight)),
            ),
            enabled: xCol.readOnly.not(),
            initialValue: value,
            dateFormat: DateFormat(format ?? "dd/MM/yy"),
            dateTextStyle: XStyles.xStyleText(fontSize: 15, colorText: Colors.white),
            initialEntryMode: DatePickerEntryMode.calendar,
            initialDatePickerMode: DatePickerMode.day,
            mode: DateTimeFieldPickerMode.date,
            autovalidateMode: AutovalidateMode.onUserInteraction,
            validator: (e) => (e?.day ?? 0) == 1 ? 'Perfavore sistema la data' : null,
            onDateSelected: (value) => onDateSelected!(value)));
  }

//Builder dei bottoni cher verranno visualizzati nell'XEditDialog
  XBtnbase builderXEditDialog_BTNs(XFDataItem item, TextEditingController controller, String valueAndLabel, bool isSconto, void Function(void Function()) parentSetState, {XCol? xCol}) {
    return XBtnbase(
        padding: EdgeInsets.all(1),
        width: 45 * XUtils.kforScale,
        label_Style: XStyles.xStyTextForSubLabel(
            textColor: valueAndLabel.contains("+")
                ? Colors.green
                : valueAndLabel.contains("-") || valueAndLabel == ("C")
                    ? Colors.red
                    : Colors.green),
        label: valueAndLabel,
        backGroundColor: Colors.grey[700],
        onPressed: () {
          if (valueAndLabel == "C") {
            controller.text = "";
            FocusScope.of(context).unfocus();
          } else {
            if (isSconto) {
              parentSetState(() {
                controller.text += calcSconto(controller, valueAndLabel);
              });
            } else {
              if (valueAndLabel.contains("-")) {
                calcCell_Negative(xCol!, controller, int.parse(valueAndLabel.replaceFirst("-", "")));
              } else {
                calcCell_Positive(xCol!, controller, int.parse(valueAndLabel.replaceFirst("+", "")));
              }
            }
            controller.selection = TextSelection(baseOffset: controller.text.length, extentOffset: controller.text.length);
          }
        });
  }

  Future<Uint8List?> generateVideoThumbnail(String blobURL) async {
    var x = await thumb.VideoThumbnail.thumbnailData(
      video: blobURL,
      imageFormat: thumb.ImageFormat.PNG,
      maxWidth: 128, // specify the width of the thumbnail, let the height auto-scaled to keep the source aspect ratio
      quality: 25,
    );
    return x;
  }

  Widget builder_ImmaginiArea(List<XMediaItem>? liImage, {String? parentID, DateTime? dt}) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liImage!
                    .where((element) => element.xDocID == (parentID))
                    .map((element) => GestureDetector(
                          onTap: () => cmd_OpenPhoto(element.payload!, element.id, dtImage: dt),
                          child: Container(margin: EdgeInsets.symmetric(horizontal: 5), width: 100, child: Image.memory(element.payload!, width: 100, height: 100)),
                        ))
                    .toList())));
  }

  Widget builder_VideoArea(List<dynamic>? liVideo, XFDataItem? xclItem) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liVideo!.where((element) => element.xDocID == xclItem!.id).map((element) {
              return GestureDetector(
                onTap: () async {
                  // var res = appServices.get
                  File x = await File.fromUri(Uri.parse(element.blobURL!));
                  VideoPlayerController? videoPlayerController = await VideoPlayerController.file(x);
                  bool _isPlaying = false;
                  Future<void> _playVideo() async {
                    await videoPlayerController.play();
                    setState(() {});
                  }

                  Future<void> _pauseVideo() async {
                    await videoPlayerController.pause();
                    setState(() {});
                  }

                  Future<void> _stopVideo() async {
                    await videoPlayerController.pause();
                    await videoPlayerController.seekTo(Duration.zero);
                    setState(() {});
                  }

                  return showDialog(
                      context: context,
                      builder: (context) {
                        videoPlayerController
                          ..addListener(() {
                            final bool isPlaying = videoPlayerController.value.isPlaying;
                            if (isPlaying != _isPlaying) {
                              setState(() {
                                _isPlaying = isPlaying;
                              });
                            }
                          })
                          ..initialize().then((_) {
                            setState(() {});
                          });
                        var i;

                        i = liVideo.firstWhereOrNull((element) => element.xDocID == element.id) != null;

                        return XAlertDialog(
                          content_insetPadding: EdgeInsets.all(0),
                          title_TextAlign: TextAlign.center,
                          title_Text: i != null ? "Video del Lavoro" : "Video del Dettaglio",
                          actionsBTNarea_Child: Row(
                            children: [
                              Expanded(
                                  child: XBtnbase(
                                label: "Pausa",
                                onPressed: () => _pauseVideo(),
                                label_Style: XStyles.xStyTextForLabel(textColor: Colors.yellow),
                              )),
                              Expanded(
                                  child: XBtnbase(
                                label: "Play",
                                onPressed: () => _playVideo(),
                                label_Style: XStyles.xStyTextForLabel(textColor: Colors.green),
                              ))
                            ],
                          ),
                          child: Stack(
                            children: [Container(width: MediaQuery.of(context).size.width - 10, child: VideoPlayer(videoPlayerController))],
                          ),
                        );
                      }).then((value) {
                    videoPlayerController.dispose();
                  });
                },
                child: Container(
                    margin: EdgeInsets.symmetric(horizontal: 5),
                    decoration: BoxDecoration(color: Colors.grey[800], image: DecorationImage(image: MemoryImage(element.miniatura!))),
                    width: 100,
                    height: 100,
                    child: Container(
                      child: Icon(Icons.play_arrow, size: 28),
                    )),
              );
            }).toList())));
  }

  Widget builder_AudioArea(List<XMediaItem>? liAudio, XFDataItem xclItem) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liAudio!
                    .where((element) => element.xDocID == xclItem.id)
                    .map((element) => GestureDetector(
                        onTap: () {},
                        child: Container(
                            margin: EdgeInsets.symmetric(horizontal: 5),
                            width: 100,
                            color: Colors.grey[800],
                            height: 100,
                            child: Container(
                                child: IconButton(
                                    icon: Icon(
                                      element.isShowDetails ? Icons.block : Icons.mic,
                                      size: 28,
                                    ),
                                    onPressed: () async {
                                      setState(() {
                                        element.isShowDetails = !element.isShowDetails;
                                      });
                                      if (element.isShowDetails) {
                                        await play(element.payload!, setState).whenComplete(() => setState(() {
                                              element.isShowDetails = false;
                                            }));
                                      } else {}
                                    })))))
                    .toList())));
  }

  Future<void> play(Uint8List audioPayload, void Function(void Function()) setState) async {
    await selectedAudioPlayer.play(BytesSource(audioPayload));
  }

  Future<void> pause() async {
    await selectedAudioPlayer.pause();
  }

  cmd_OpenPhoto(Uint8List img, String imgID, {DateTime? dtImage}) async {
    await showDialog(
        context: context,
        builder: (builder) {
          return XAlertDialog(
              child: Container(
                  width: MediaQuery.of(context).size.width - 1,
                  height: MediaQuery.of(context).size.height - 1,
                  child: PhotoViewGallery.builder(
                      scrollPhysics: const BouncingScrollPhysics(),
                      builder: (BuildContext context, int index) {
                        return PhotoViewGalleryPageOptions(
                          basePosition: Alignment.center,
                          imageProvider: MemoryImage(img),
                          initialScale: PhotoViewComputedScale.contained * 1,
                          heroAttributes: PhotoViewHeroAttributes(tag: imgID),
                        );
                      },
                      itemCount: 1,
                      backgroundDecoration: BoxDecoration(color: Colors.grey[900]))),
              title_Text: dtImage != null ? "Foto del ${XUtils.dateToString(dtImage, format: "dd/MM/yy")}" : "Foto",
              title_Style: XStyles.xStyTextForLabel(textColor: Colors.yellow),
              content_insetPadding: EdgeInsets.all(0),
              actionsBTNarea_Child: Row(children: [
                Expanded(
                    child: XBtnbase(
                  height: 35,
                  backGroundColor: Colors.transparent,
                  onPressed: () => Navigator.pop(context),
                  elevation: 0,
                  label: "Chiudi",
                  label_Style: XStyles.xStyTextForLabel(textColor: Colors.red),
                ))
              ]));
        });
  }
}
